%global leapp_datadir %{_datadir}/leapp-repository
%global repositorydir %{leapp_datadir}/repositories
%global custom_repositorydir %{leapp_datadir}/custom-repositories

%define leapp_repo_deps  10

%if 0%{?rhel} == 7
    %define leapp_python_sitelib %{python2_sitelib}
    %define lpr_name leapp-upgrade-el7toel8
%else
    %define leapp_python_sitelib %{python3_sitelib}
    %define lpr_name leapp-upgrade-el8toel9

    # This drops autogenerated deps on
    #    - /usr/libexec/platform-python  (rhel-8 buildroot)
    #    - /usr/bin/python3.x (epel-8 buildroot)
    #    - python(abi) = 3.x
    # Each of these lead into the removal of leapp rpms as python is changed between
    # major versions of RHEL
    %global __requires_exclude ^python\\(abi\\) = 3\\..+|/usr/libexec/platform-python|/usr/bin/python.*
%endif


# TODO: not sure whether it's required nowadays. Let's check it and drop
# the whole block if not.
%if 0%{?rhel} == 7
# Defining py_byte_compile macro because it is not defined in old rpm (el7)
# Only defined to python2 since python3 is not used in RHEL7
%{!?py_byte_compile: %global py_byte_compile py2_byte_compile() {\
    python_binary="%1"\
    bytecode_compilation_path="%2"\
    find $bytecode_compilation_path -type f -a -name "*.py" -print0 | xargs -0 $python_binary -c 'import py_compile, sys; [py_compile.compile(f, dfile=f.partition("$RPM_BUILD_ROOT")[2]) for f in sys.argv[1:]]' || :\
    find $bytecode_compilation_path -type f -a -name "*.py" -print0 | xargs -0 $python_binary -O -c 'import py_compile, sys; [py_compile.compile(f, dfile=f.partition("$RPM_BUILD_ROOT")[2]) for f in sys.argv[1:]]' || :\
}\
py2_byte_compile "%1" "%2"}
%endif


# We keeps the leapp-repository name for the component, however we do not plan
# to create such an rpm. Instead, we are going to introduce new naming for
# RHEL 8+ packages to be consistent with other leapp projects in future.

Name:           leapp-repository
Version:        0.20.0
Release:        2.0.9%{?dist}
Summary:        Repositories for leapp

License:        ASL 2.0
URL:            https://oamg.github.io/leapp/
Source0:        https://github.com/oamg/%{name}/archive/v%{version}.tar.gz#/%{name}-%{version}.tar.gz
Source1:        deps-pkgs-10.tar.gz

# NOTE: Our packages must be noarch. Do no drop this in any way.
BuildArch:      noarch

### PATCHES HERE
# Patch0001:    filename.patch

Patch0001:      0001-rhui-do-not-bootstrap-target-client-on-aws.patch

#Oracle patches
Patch1001:      0001-Add-support-for-UEK-kernel.patch
Patch1002:      0002-Remove-files.patch
Patch1003:      0003-Add-Oracle-specific-json-files.patch
Patch1004:      0004-Add-support-for-Oracle-Linux.patch
Patch1005:      0005-Rename-upstream-specific-actors-to-use-Oracle-naming.patch
Patch1006:      0006-UEKR6-Overlayfs-fix.patch
Patch1007:      0007-Replace-Upstream-Bugzilla-URLs.patch
Patch1008:      0008-Update-upstream-refs.patch
Patch1009:      0009-Remove-generic-BTRFS-check-actor.patch
Patch1010:      0010-Remove-upstream-SM.patch
Patch1011:      0011-Add-Upgrade-Repositories.patch
Patch1012:      0012-Fix-SCTP-crash-on-arm.patch
Patch1013:      0013-Keep-Default-Boot-Kernel.patch
Patch1014:      0014-Add-Oracle-DNF-Plugin.patch
Patch1015:      0015-BTRFS-RAID-Upgrade-Initramfs-fix.patch
Patch1016:      0016-Set-All-Installed-Kernel-Parameters.patch
Patch1017:      0017-Etc-Sysconfig-Kernel-fix.patch
Patch1018:      0018-Fix-License-Reboot-Issue.patch
Patch1019:      0019-Support-OCI-Vars.patch
Patch1020:      0020-Fix-Cloud-Init-Cache-After-Upgrade.patch
Patch1021:      0021-Detect-and-Inhibit-OCI-BM-Shapes.patch
Patch1022:      0022-EFI-Grubenv-Fix_OL8.patch
Patch1023:      0023-Post-Enable-Repos.patch
Patch1024:      0024-KVM-Persistentnetnames-Fix.patch
Patch1025:      0025-Remove-Upstream-SM-Args.patch
Patch1026:      0026-Add-Oracle-Repos-parameters.patch
Patch1027:      0027-OCI-vars-substitution.patch
Patch1028:      0028-Fix-Upgrade-Emergency-Shell-Issue.patch
Patch1029:      0029-remove-upstream-refs.patch
Patch1030:      0030-update-remediation-example.patch
Patch1031:      0031-Replace-Upstream-Refs.patch
Patch1032:      0032-Remove-make-devel-package.patch
Patch1033:      0033-Fix-typo-in-pes_events_scanner.py.patch
Patch1034:      0034-Port-Redhat-ISO-functionality-to-OL.patch
Patch1035:      0035-Add-Oracle-GPG-Keys.patch
Patch1036:      0036-Add-datastream-information.patch
Patch1037:      0037-Remove-unwanted-upstream-functionality.patch
Patch1038:      0038-Replace-new-refs.patch
Patch1039:      0039-Bump-repomap.json-version-format.patch
Patch1040:      0040-Fix-unhandled-error-output-for-package-conflict-on-O.patch
Patch1041:      0041-Correctly-parse-multi-line-output-for-boot-dev.patch
Patch1042:      0042-Update-latest-RH-references.patch
Patch1043:      0043-Correctly-report-source_os-and-target_os-for-OL.patch
Patch1044:      0044-Address-additional-upstream-references.patch
Patch1045:      0045-Update-latest-upstream-references.patch
Patch1046:      0046-lvm2-cluster-check.patch
Patch1047:      0047-Use-updated-deprecated-device-list-for-UEK.patch
Patch1048:      0048-implement-OFED-inhibitor.patch
Patch1049:      0049-OLM-version-check.patch
Patch1050:      0050-Oracle-KVM-Check.patch
Patch1051:      0051-Replace-deprecated-tags-and-flags-with-groups.patch
Patch1052:      0052-add-gluster8-repo-and-package-mappings.patch
Patch1053:      0053-Remove-libfabric-on-update-if-Oracle-RDMA-packages-a.patch
Patch1054:      0054-Correctly-report-supported-and-unsupported-status-of.patch
Patch1055:      0055-Fix-condition-in-actor-removing-libfabrics.patch
Patch1056:      0056-Add-support-for-OLCNE-1.5-and-1.4.patch
Patch1057:      0057-Update-repository-file-to-use-ocidomain-variable.patch
Patch1058:      0058-Correctly-update-kernel-args-for-OL8-kernels.patch
Patch1059:      0059-Add-support-for-OLCNE-1.6-repositories.patch
Patch1060:      0060-Fix-for-oled-tools-dtrace-utils-failed-upgrade.patch
Patch1061:      0061-Add-Oracle-instantclient-repositories.patch
Patch1062:      0062-Implement-I686-Inhibitor-Actor.patch
Patch1063:      0063-Check-OSMS-Inhibit-Actor.patch
Patch1064:      0064-Introduce-OSMS-support.patch
Patch1065:      0065-Produce-different-reports-for-cloud-agent-and-osms-c.patch
Patch1066:      0066-Restore-OSMS-backed-up-repo-if-needed.patch
Patch1067:      0067-Auto-detect-that-system-is-OCI-managed-instance.patch
Patch1068:      0068-Update-OSMS-inhibitor.patch
Patch1069:      0069-Remove-osms-flag.patch
Patch1070:      0070-Add-ALX-inhibitor.patch
Patch1071:      0071-Correctly-upgrade-python2-jmespath.patch
Patch1072:      0072-Fix-typo-in-cloud-init-actor.patch
Patch1073:      0073-Introduce-oci-ruby-sdk-inhibitor.patch
Patch1074:      0074-Implement-InstantClient-Actor-and-Inhibitors.patch
Patch1075:      0075-Fix-i686-inhibitor-and-add-mariadb-packages.patch
Patch1076:      0076-Allow-upgrading-setools-gui.patch
Patch1077:      0077-update-deprecated-tags-flags.patch
Patch1078:      0078-Identify-kernel-uek-correctly.patch
Patch1079:      0079-Update-Docker-reference.patch
Patch1080:      0080-BTRFS-RAID-inhibit.patch
Patch1081:      0081-Fix-postgresql-actor-references.patch
#OSMH support
Patch1082:      0082-Support-upgrading-OSMH-managed-instances.patch
Patch1083:      0083-Drop-some-repos-auto-mapping-for-OSMH-upgrade.patch
Patch1084:      0084-Do-not-modify-leapp-repository-file-for-OSMH.patch
Patch1085:      0085-Do-not-detect-OSMH-just-by-package-presence.patch
Patch1086:      0086-Update-repomapper-service-to-ensure-OCI-vars-are-alw.patch
Patch1088:      0088-Confirm-upgrade-condition-for-OSMH.patch
Patch1089:      0089-modify-actors-further-for-OSMH.patch
Patch1090:      0090-Do-not-restart-oracle-cloud-agent-to-prevent-OSMH-pl.patch

Patch1091:      0091-Util-Linux.patch
Patch1092:      0092-Upgrade-Help-ISO-OSMS.patch
#ALX support
Patch1093:      0093-Allow-upgrading-ALX-instances.patch
Patch1094:      0094-Implement-separate-set-of-confirmation-for-ALX-insta.patch
Patch1095:      0095-Add-support-for-additional-repositories.patch
Patch1096:      0096-Remove-rh-ruby30-runtime-package.patch
Patch1097:      0097-Unconditionally-remove-ELS-repository-package.patch
Patch1098:      0098-Kernel-Selection-Fix.patch
# Generic patches
Patch1099:       0099-Update-conditions-for-OSMH-upgrade.patch
Patch10100:      0100-resource-limit-backport.patch
Patch10101:      0101-Pre-set-enabled-repos-variable.patch

%description
%{summary}


# This is the real RPM with the leapp repositories content
%package -n %{lpr_name}
Summary: Leapp repositories for the in-place upgrade

%if 0%{?rhel} == 7
######### RHEL 7 ############
BuildRequires:  python-devel
Requires:       python2-leapp

# We should not drop this on RHEL 7 because of the compatibility reasons
Obsoletes:      leapp-repository-data <= 0.6.1
Provides:       leapp-repository-data <= 0.6.1

# Former leapp subpackage that is part of the sos package since RHEL 7.8
Obsoletes:      leapp-repository-sos-plugin <= 0.10.0

# Set the conflict to be sure this RPM is not upgraded automatically to
# the one from the target (upgraded) RHEL. The RPM has to stay untouched
# during the whole IPU process.
# The manual removal of the RPM is required after the IPU
Conflicts:      leapp-upgrade-el8toel9

%else
######### RHEL 8 ############
BuildRequires:  python3-devel
Requires:       python3-leapp

# Same as the conflict above - we want to be sure our packages are untouched
# during the whole IPU process
Conflicts:      leapp-upgrade-el7toel8

%endif

# IMPORTANT: every time the requirements are changed, increment number by one
# - same for Provides in deps subpackage
Requires:       leapp-repository-dependencies = %{leapp_repo_deps}

# IMPORTANT: this is capability provided by the leapp framework rpm.
# Check that 'version' instead of the real framework rpm version.
Requires:       leapp-framework >= 5.0

# Since we provide sub-commands for the leapp utility, we expect the leapp
# tool to be installed as well.
Requires:       leapp

# Used to determine RHEL version of a given target RHEL installation image -
# uncompressing redhat-release package from the ISO.
Requires:   cpio

# The leapp-repository rpm is renamed to %%{lpr_name}
Obsoletes:      leapp-repository < 0.14.0-5
Provides:       leapp-repository = %{version}-%{release}

# Provide "leapp-upgrade" for the user convenience. Users will be pointed
# to install "leapp-upgrade" in the official docs.
Provides:       leapp-upgrade = %{version}-%{release}

# Provide leapp-commands so the framework could refer to them when customers
# do not have installed particular leapp-repositories
Provides:       leapp-command(answer)
Provides:       leapp-command(preupgrade)
Provides:       leapp-command(upgrade)
Provides:       leapp-command(rerun)
Provides:       leapp-command(list-runs)

%description -n %{lpr_name}
Leapp repositories for the in-place upgrade to the next major version
of the Oracle Linux system.




# This metapackage should contain all RPM dependencies excluding deps on *leapp*
# RPMs. This metapackage will be automatically replaced during the upgrade
# to satisfy dependencies with RPMs from target system.
%package -n %{lpr_name}-deps
Summary:    Meta-package with system dependencies of %{lpr_name} package

# The package has been renamed, so let's obsoletes the old one
Obsoletes:      leapp-repository-deps < 0.14.0-5

# IMPORTANT: every time the requirements are changed, increment number by one
# - same for Requires in main package
Provides:  leapp-repository-dependencies = %{leapp_repo_deps}
##################################################
# Real requirements for the leapp-repository HERE
##################################################
Requires:   dnf >= 4
Requires:   pciutils

# required to be able to format disk images with XFS file systems (default)
Requires:   xfsprogs

# required to be able to format disk images with Ext4 file systems
# NOTE: this is not happening by default, but we can expact that many customers
# will want to / need to do this - especially on RHEL 7 now. Adding this deps
# as the best trade-off to resolve this problem.
Requires:   e2fsprogs

%if 0%{?rhel} && 0%{?rhel} == 7
# Required to gather system facts about SELinux
Requires:   libselinux-python
Requires:   python-pyudev
# required by SELinux actors
Requires:   policycoreutils-python
# Required to fetch leapp data
Requires:   python-requests

%else
############# RHEL 8 dependencies (when the source system is RHEL 8) ##########
# systemd-nspawn utility
Requires:   systemd-container
Requires:   python3-pyudev
# Required to fetch leapp data
Requires:   python3-requests
# Required because the code is kept Py2 & Py3 compatible
Requires:   python3-six
# required by SELinux actors
Requires:   policycoreutils-python-utils
# required by systemfacts, and several other actors
Requires:   procps-ng
Requires:   kmod
# since RHEL 8+ dracut does not have to be present on the system all the time
# and missing dracut could be killing situation for us :)
Requires:   dracut

# Required to scan NetworkManagerConnection (e.g. to recognize secrets)
# NM is requested to be used on RHEL 8+ systems
Requires:   NetworkManager-libnm
Requires:   python3-gobject-base

%endif
##################################################
# end requirement
##################################################


%description -n %{lpr_name}-deps
%{summary}


%prep
%setup -n %{name}-%{version}
%setup -q  -n %{name}-%{version} -D -T -a 1

# APPLY PATCHES HERE
# %%patch0001 -p1
%patch0001 -p1

#Oracle patches
%patch1001 -p1
%patch1002 -p1
%patch1003 -p1
%patch1004 -p1
%patch1005 -p1
%patch1006 -p1
%patch1007 -p1
%patch1008 -p1
%patch1009 -p1
%patch1010 -p1
%patch1011 -p1
%patch1012 -p1
%patch1013 -p1
%patch1014 -p1
%patch1015 -p1
%patch1016 -p1
%patch1017 -p1
%patch1018 -p1
%patch1019 -p1
%patch1020 -p1
%patch1021 -p1
%patch1022 -p1
%patch1023 -p1
%patch1024 -p1
%patch1025 -p1
%patch1026 -p1
%patch1027 -p1
%patch1028 -p1
%patch1029 -p1
%patch1030 -p1
%patch1031 -p1
%patch1032 -p1
%patch1033 -p1
%patch1034 -p1
%patch1035 -p1
%patch1036 -p1
%patch1037 -p1
%patch1038 -p1
%patch1039 -p1
%patch1040 -p1
%patch1041 -p1
%patch1042 -p1
%patch1043 -p1
%patch1044 -p1
%patch1045 -p1
%patch1046 -p1
%patch1047 -p1
%patch1048 -p1
%patch1049 -p1
%patch1050 -p1
%patch1051 -p1
%patch1052 -p1
%patch1053 -p1
%patch1054 -p1
%patch1055 -p1
%patch1056 -p1
%patch1057 -p1
%patch1058 -p1
%patch1059 -p1
%patch1060 -p1
%patch1061 -p1
%patch1062 -p1
%patch1063 -p1
%patch1064 -p1
%patch1065 -p1
%patch1066 -p1
%patch1067 -p1
%patch1068 -p1
%patch1069 -p1
%patch1070 -p1
%patch1071 -p1
%patch1072 -p1
%patch1073 -p1
%patch1074 -p1
%patch1075 -p1
%patch1076 -p1
%patch1077 -p1
%patch1078 -p1
%patch1079 -p1
%patch1080 -p1
%patch1081 -p1
%patch1082 -p1
%patch1083 -p1
%patch1084 -p1
%patch1085 -p1
%patch1086 -p1

%patch1088 -p1
%patch1089 -p1
%patch1090 -p1
%patch1091 -p1
%patch1092 -p1
%patch1093 -p1
%patch1094 -p1
%patch1095 -p1
%patch1096 -p1
%patch1097 -p1
%patch1098 -p1
%patch1099 -p1

%patch10100 -p1
%patch10101 -p1

%build
%if 0%{?rhel} == 7
cp -a leapp*deps*el8.noarch.rpm repos/system_upgrade/el7toel8/files/bundled-rpms/
# part of patch 1008-Remove-Upstream-SM.patch
rm -rf repos/system_upgrade/common/actors/checkrhsmsku
rm -rf repos/system_upgrade/common/actors/cloud/checkrhui
rm -rf repos/system_upgrade/common/actors/reportsettargetrelease
mv repos/system_upgrade/common/actors/commonleappdracutmodules/files/dracut/85sys-upgrade-redhat repos/system_upgrade/common/actors/commonleappdracutmodules/files/dracut/85sys-upgrade-oracle
# part of patch 1012-Add-Oracle-DNF-Plugin.patch
rm -f repos/system_upgrade/common/files/rhel_upgrade.py
# Fix pcis scanner issue
rm -rf repos/system_upgrade/common/actors/restrictedpcisscanner
rm -rf repos/system_upgrade/el7toel8/actors/checkpcidrivers
rm -rf repos/system_upgrade/common/actors/pcidevicesscanner
%else
cp -a leapp*deps*el9.noarch.rpm repos/system_upgrade/el8toel9/files/bundled-rpms/
%endif


%install
install -m 0755 -d %{buildroot}%{custom_repositorydir}
install -m 0755 -d %{buildroot}%{repositorydir}
cp -r repos/* %{buildroot}%{repositorydir}/
install -m 0755 -d %{buildroot}%{_sysconfdir}/leapp/repos.d/
install -m 0755 -d %{buildroot}%{_sysconfdir}/leapp/transaction/
install -m 0755 -d %{buildroot}%{_sysconfdir}/leapp/files/
install -m 0644 etc/leapp/transaction/* %{buildroot}%{_sysconfdir}/leapp/transaction
install -m 0644 etc/leapp/files/* %{buildroot}%{_sysconfdir}/leapp/files

install -m 0755 -d %{buildroot}%{_sysconfdir}/yum.repos.d/
install -m 0644 etc/leapp/files/* %{buildroot}%{_sysconfdir}/leapp/files
install -m 0644 etc/yum.repos.d/* %{buildroot}%{_sysconfdir}/yum.repos.d

# install CLI commands for the leapp utility on the expected path
install -m 0755 -d %{buildroot}%{leapp_python_sitelib}/leapp/cli/
cp -r commands %{buildroot}%{leapp_python_sitelib}/leapp/cli/
rm -rf %{buildroot}%{leapp_python_sitelib}/leapp/cli/commands/tests

# Remove irrelevant repositories - We don't want to ship them for the particular
# RHEL version
%if 0%{?rhel} == 7
rm -rf %{buildroot}%{repositorydir}/system_upgrade/el8toel9
%else
rm -rf %{buildroot}%{repositorydir}/system_upgrade/el7toel8
%endif

# remove component/unit tests, Makefiles, ... stuff that related to testing only
rm -rf %{buildroot}%{repositorydir}/common/actors/testactor
find %{buildroot}%{repositorydir}/common -name "test.py" -delete
rm -rf `find %{buildroot}%{repositorydir} -name "tests" -type d`
find %{buildroot}%{repositorydir} -name "Makefile" -delete
find %{buildroot} -name "*.py.orig" -delete

for DIRECTORY in $(find  %{buildroot}%{repositorydir}/  -mindepth 1 -maxdepth 1 -type d);
do
    REPOSITORY=$(basename $DIRECTORY)
    echo "Enabling repository $REPOSITORY"
    ln -s  %{repositorydir}/$REPOSITORY  %{buildroot}%{_sysconfdir}/leapp/repos.d/$REPOSITORY
done;

# __python2 could be problematic on systems with Python3 only, but we have
# no choice as __python became error on F33+:
#   https://fedoraproject.org/wiki/Changes/PythonMacroError
%if 0%{?rhel} == 7
%py_byte_compile %{__python2} %{buildroot}%{repositorydir}/*
%else
%py_byte_compile %{__python3} %{buildroot}%{repositorydir}/*
%endif

%files -n %{lpr_name}
%doc README.md
%license LICENSE
%dir %{_sysconfdir}/leapp/transaction
%dir %{_sysconfdir}/leapp/files
%dir %{leapp_datadir}
%dir %{repositorydir}
%dir %{custom_repositorydir}
%dir %{leapp_python_sitelib}/leapp/cli/commands
%config %{_sysconfdir}/leapp/files/*
%{_sysconfdir}/leapp/repos.d/*
%{_sysconfdir}/leapp/transaction/*
%{repositorydir}/*
%{leapp_python_sitelib}/leapp/cli/commands/*
%{_sysconfdir}/leapp/files/*
%{_sysconfdir}/yum.repos.d/*


%files -n %{lpr_name}-deps
# no files here

%changelog
* Fri Apr 25 2025 Joseph Oliver <joseph.oliver@oracle.com> 0.20.0-2.0.9
- Pre-set enabled repos variable [JIRA: OLDIS-43582], [JIRA: OLDIS-43583]
- Backported resource limit fix from upstream commit: c217010bba61bbf8587030d4a4cb98fd7ced3ef7 [Orabug: 37734643]
- Relax conditions for OSMH upgrade [JIRA: OLDIS-43582], [JIRA: OLDIS-43583]

* Mon Mar 03 2025 Joseph Oliver <joseph.oliver@oracle.com> - 0.20.0-2.0.8
- Implemented logic to prevent boot kernel from defaulting to RHCK and ensuring boot kernel is correctly mapped [Orabug: 36441642]

* Tue Dec 14 2024 Alex Burmashev <alexander.burmashev@oracle.com> - 0.20.0-2.0.7
- Allow upgrading ALX instances [JIRA: OLDIS-35268]
- Properly handle ELS repositories [Orabug: 37545188]

* Mon Nov 04 2024 Joseph Oliver <joseph.oliver@oracle.com> - 0.20.0-2.0.6
- Removed redundant help section from leapp preupgrade & upgrade [Orabug: 37180324]

* Wed Oct 09 2024 Joseph Oliver <joseph.oliver@oracle.com> - 0.20.0-2.0.5
- Backported fix for util-linux issue [Orabug: 37125470]

* Tue Oct 01 2024 Alex Burmashev <alexander.burmashev@oracle.com> - 0.20.0-2.0.3
- Additional logic to handle inhibitors and confirmation for OSMH upgrade [Orabug: 37106208]
- Do not restart OSMH service when not needed [JIRA: OLDIS-35624]
- Additional confirmation for OSMH upgrade [Orabug: 37106208]
- Further adjust repo checking logic [JIRA: OLDIS-35624]
- Ensure repomapper service triggers when expected [JIRA: OLDIS-35624]
- Do not create additional repo files for OSMH [JIRA: OLDIS-35624]
- Do not detect OSMH just based on package presence [JIRA: OLDIS-35624]
- Fix OSMH code [JIRA: OLDIS-35624]
- Drop some auto repomappings for OSMH upgrade [JIRA: OLDIS-35624]
- Support upgrading OSMH managed instances [JIRA: OLDIS-35624]

* Mon Jul 15 2024 Alex Burmashev <alexander.burmashev@oracle.com> - 0.20.0-2.0.1
- Ported Oracle patches to leapp 0.20.0
- Added OL8 code that is applicable to OL7
- Refactored some patches
- Improve python36-idna upgrade paths
- Implement Actor to resolve DHCP issue [Orabug: 36702507]
- Enable upgrade path report patch back for 8.10 release [Orabug: 36544453]
- Disable upgrade path patch to ensure correct reporting [Orabug: 36544453]
- Correctly handle i686 mariadb packages [Orabug: 35988257]
- Correctly suggest needed actions in case of unsupported kernel drivers [Orabug: 36459641]
- Report correct upgrade path for 8.10 [Orabug: 36544453]
- Correctly handle libfabrics [Orabug: 36477821]
- Allow upgrading setools [Orabug: 35987829]
- Implemented instantclient fix and inhibitor [Orabug: 36399314]
- Correctly upgrade python2-jmespath [Orabug: 36459278]
- Fix typo in cloud-init actor [Orabug: 36460137]
- Introduce oci-ruby-sdk inhibitor [Orabug: 36459036]
- Report upgrade path as 8.9 [Orabug: 36472148]
- Inhibit upgrade on ALX instance [JIRA: OLDIS-31414]
- Auto-detect if system is an OCI managed instance
- Update OSMS inhibitor report [Orabug: 36434437]
- Remove --osms flag
- Restore OSMS backed-up repositories, if needed [Orabug: 36428674]
- Produce different reports for different OCI managed instance upgrade cases
- Allow upgrading of OCI managed instances
- Implemented inhibitor for USBGuard issue [Orabug: 36099671]
- Ported over several systemd actors from upstream to resolve broken symlinks issue [Orabug: 35345629]
- Resolved an issue preventing upgrade to OL8 if oled-tools/dtrace-utils was installed [Orabug: 35458749]
- Add OLCNE 1.6 repositories support [Orabug: 35566511]
- Correctly identify OL8 kernels [Orabug: 35343015]
- Update repository file to correctly use ocidomain variable [Orabug: 34999903]
- Add support for OLCNE repositories [Orabug: 34824785]
- Addressed upgrade issue with libfabric by removing package
  to prevent RDMA conflict on OL upgrade [Orabug: 34909881]
  - Add Oracle Patches to fix certain bug:
  - 1037-Glusterfs8-Support.patch
  - [Orabug: 34968415]
  - [Orabug: 32187416]
  - [Orabug: 32076068]
  - [Orabug: 32187416]
  - [Orabug: 32076068]
  - [Orabug: 32187481]
  - [Orabug: 32076068]
  - [Orabug: 32076068]
  - [Orabug: 32187404]
  - [Orabug: 32076068]
  - [Orabug: 32214409]
  - [Orabug: 32248761]
  - [Orabug: 32251187]
  - [Orabug: 32076068]
  - [Orabug: 32295600]
  - [Orabug: 32251187]
  - [Orabug: 32251187]
  - [Orabug: 32295600]
  - [JIRA: OLDIS-3436]
  - [Orabug: 32612983]
  - [Orabug: 32826595]
  - [Orabug: 32857588]
  - [Orabug: 32858440]
  - [Orabug: 32858036]
  - [Orabug: 33155026]
  - [Orabug: 33124455]
  - [Orabug: 33181141]
  - [Orabug: 33252470]
  - [Orabug: 33210937]
  - [Orabug: 33599932]
  - [Orabug: 33639916]
  - [Orabug: 33573562]
  - [Orabug: 32076068]
  - [JIRA: OLDIS-5135]
  - [Orabug: 34685557]

* Tue Feb 20 2024 Petr Stodulka <pstodulk@redhat.com> - 0.20.0-2
- Fallback to original RHUI solution on AWS to fix issues caused by changes in RHUI client
- Resolves: RHEL-21449

* Tue Feb 13 2024 Toshio Kuratomi <toshio@fedoraproject.org> - 0.20.0-1
- Rebase to new upstream v0.20.0.
- Fix semanage import issue
- Fix handling of libvirt's systemd services
- Add a dracut breakpoint for the pre-upgrade step.
- Drop obsoleted upgrade paths (obsoleted releases: 8.6, 8.9)
- Resolves: RHEL-21449, RHEL-3295

* Tue Jan 23 2024 Toshio Kuratomi <toshio@fedoraproject.org> - 0.19.0-5
- Print nice error msg when device and driver deprecation data is malformed
- Fix another cornercase when preserving symlinks to certificates in /etc/pki
- Resolves: RHEL-3284

* Fri Jan 19 2024 Petr Stodulka <pstodulk@redhat.com> - 0.19.0-4
- Do not try to download data files anymore when missing as the service
  is obsoleted since the data is part of installed packages
- Update error messages and reports when installed upgrade data files
  are malformed or missing to instruct user how to resolve it
- Update the leapp upgrade data files - bump data stream to "3.0"
- Resolves: RHEL-18298

* Fri Jan 12 2024 Petr Stodulka <pstodulk@redhat.com> - 0.19.0-3
- Add detection of possible usage of OpenSSL IBMCA engine on IBM Z machines
- Add detection of modified /etc/pki/tls/openssl.cnf file
- Update the leapp upgrade data files
- Fix handling of symlinks under /etc/pki with relative paths specified
- Report custom actors and modifications of the upgrade tooling
- Requires xfsprogs and e2fsprogs to ensure that Ext4 and XFS tools are installed
- Fix the upgrade of the RH Satellite server when tomcat is installed
- Bump leapp-repository-dependencies to 10
- Resolves: RHEL-10847, RHEL-10703, RHEL-21449, RHEL-11193, RHEL-3284

* Thu Nov 16 2023 Petr Stodulka <pstodulk@redhat.com> - 0.19.0-2
- Enable new upgrade path for RHEL 8.10 -> RHEL 9.4 (including RHEL with SAP HANA)
- Introduce generic transition of systemd services states during the IPU
- Introduce possibility to upgrade with local repositories
- Improve possibilities of upgrade when a proxy is configured in DNF configutation file
- Fix handling of symlinks under /etc/pki when managing certificates
- Fix the upgrade with custom https repositories
- Default to the NO_RHSM mode when subscription-manager is not installed
- Detect customized configuration of dynamic linker
- Drop the invalid `tuv` target channel for the --channel option
- Fix the issue of going out of bounds in the isccfg parser
- Fix traceback when saving the rhsm facts results and the /etc/rhsm/facts directory doesn’t exist yet
- Load all rpm repository substitutions that dnf knows about, not just "releasever" only
- Simplify handling of upgrades on systems using RHUI, reducing the maintenance burden for cloud providers
- Detect possible unexpected RPM GPG keys has been installed during RPM transaction
- Resolves: RHEL-3272, RHEL-11958, RHEL-3284, RHEL-11347

* Wed Aug 23 2023 Petr Stodulka <pstodulk@redhat.com> - 0.19.0-1
- Rebase to v0.19.0
- Requires leapp-framework 5.0
- Handle correctly the installed certificates to allow upgrades with custom repositories using HTTPs with enabled SSL verification
- Fix failing upgrades with devtmpfs file systems specified in FSTAB
- Do not try to update GRUB core on IBM Z systems
- Minor improvements and fixes of various reports and error messages
- Redesign handling of information about kernel (booted and target)
- Use new leapp CLI API which provides better report summary output
- Resolves: rhbz#2215027, rhbz#2040706, rhbz#2215998

* Tue Jul 18 2023 Petr Stodulka <pstodulk@redhat.com> - 0.18.0-5
- Fix the calculation of the required free space on each partitions/volume for the upgrade transactions
- Create source overlay images with dynamic sizes to optimize disk space consumption
- Update GRUB2 when /boot resides on multiple devices aggregated in RAID
- Use new leapp CLI API which provides better report summary output
- Introduce possibility to add (custom) kernel drivers to initramfs
- Fix the generation of the report about hybrid images
- Minor improvements and fixes of various reports
- Requires leapp-framework 4.0
- Update leapp data files
- Fix false positive report about invalid symlinks on RHEL 7
- Resolves: #1832730, #1871076, #2134213, #2215998, #2219544

* Mon Jun 19 2023 Petr Stodulka <pstodulk@redhat.com> - 0.18.0-4
- Introduce new upgrade path RHEL 7.9 -> 8.9 (default)
- Update leapp data files to reflect new changes between systems
- Minor improvements of generated reports
- Fix false positive report about invalid symlinks
- Resolves: #2215998

* Mon Jun 05 2023 Petr Stodulka <pstodulk@redhat.com> - 0.18.0-3
- Update the repomap.json file to address planned changes on RHUI Azure
- Resolves: #2203253

* Thu May 11 2023 Petr Stodulka <pstodulk@redhat.com> - 0.18.0-2
- Include leap data files in the package
- Change the upgrade paths for RHEL with SAP HANA:
      RHEL with SAP HANA 7.9 -> 8.6, 8.8 (default: 8.6)
- Resolves: #2203253

* Tue Mar 07 2023 Petr Stodulka <pstodulk@redhat.com> - 0.18.0-1
- Rebase to v0.18.0
- Set new upgrade paths RHEL 7.9 -> 8.8, 8.6 (default: 8.8)
- Requires cpio
- Bump leapp-repository-dependencies to 9
- Add breadcrumbs results to RHSM facts unless --no-rhsm-facts is used
- Register subscribed systems automatically to Red Hat Insights unless --no-insights-register is used
- Add leapp RHUI packages to an allowlist to drop confusing reports
- Check RPM signatures during the upgrade
- Check only mounted XFS partitions
- Check the validity and compatitibility of used leapp data
- Detect a proxy configuration in YUM/DNF and adjust an error msg on issues caused by the configuration
- Detect and report systemd symlinks that are broken before the upgrade
- Detect corrupted grubenv file
- Disable the amazon-id DNF plugin on AWS during the upgrade stage to omit error messages during the upgrade process caused by missing network connection
- Do not create new *pyc files when running leapp after the DNF upgrade transaction
- Drop obsoleted upgrade paths
- Enable upgrades on s390x when /boot is part of rootfs
- Ensure that rsyncd stays enabled if it is enabled prior the upgrade
- Ensure the device_cio_free service stays enabled on s390x after the upgrade
- Extend the allow list of RHUI clients by azure-sap-apps to omit confusing report
- Filter out PES events unrelated for the used upgrade path and handle overlapping events
 (fixes upgrades with quagga installed)
- Fix scan of ceph volumes on systems without ceph-osd or when ceph-osd container is not found
- Fix systemd symlinks that become incorrect during the IPU
- Fix the check of memory (RAM) limits and use human readable values in the report
- Fixed checks for RHEL SAP IPU 7.9 -> 8.6
- Fixed migration of ntp to chrony when the ntp service is masked
- Ignore external accounts in /etc/passwd
- Improve remediation instructions for packages in unknown repositories
- Improve the error message to guide users when discovered more space is needed
- Inhibit the upgrade when entries in /etc/fstab cause overshadowing during the upgrade
- Introduced an option to use an ISO file as a target RHEL version content source
- Introduced possibility to specify what systemd services should be enabled/disabled on the upgraded system
- Introduced the --nogpgcheck option to skip checking of RPM signatures
- Map the target repositories also based on the installed content
- Prevent re-run of leapp in the upgrade initramfs in case of previous failure
- Prevent the upgrade with RHSM when Baseos and Appstream target repositories are not discovered
- Prevent the traceback during migration of sendmail configuration files when the package is not installed
- Provide common information about systemd services
- RHUI(Azure) Handle correctly various SAP images
- Remove obsoleted GPG keys provided by RH after the upgrade to prevent errors
- Rework the network configuration handling and parse the configuration data properly
- Set the system release lock after the upgrade also for premium channels
- Small improvements and fixes in various reports
- Resolves: #2143374, #1901440, #1905519, #1972238, #1988449, #1988457, #2014009
- Resolves: #2031098, #2032953, #2055117, #2088491, #2089514, #2110045, #2122712
- Resolves: #2127918, #2158527, #2159288, #2162785, #2163796

* Mon Feb 27 2023 Petr Stodulka <pstodulk@redhat.com> - 0.17.0-10
- Re-apply the fix for handling of upgrades on s390x with ZFCP to correctly
  convert the ZIPL configuration to BLS format
- Resolves: #2140563

* Tue Feb 14 2023 Petr Stodulka <pstodulk@redhat.com> - 0.17.0-8
- Ensure that satellite metapackages are installed after the upgrade
- Satellite: reindex all related databases to fix issues due to new locales in RHEL 8
- Resolves: #2142270

* Fri Nov 11 2022 Petr Stodulka <pstodulk@redhat.com> - 0.17.0-2
- Fix the upgrade on s390x with ZFCP
- Resolves: #2140563

* Wed Aug 24 2022 Michal Hecko <mhecko@redhat.com> - 0.17.0-1
- Rebase to v0.17.0
- The default upgrade path for RHEL SAP is 7.9 -> 8.6
- Provide and require leapp-repository-dependencies 7
- Provide `leapp-command(<CMD>)` for each CLI command provided by leapp-repository
- Require dracut, kmod, procps-ng on RHEL 8+
- Require leapp-framework >= 3.1
- Detect and fix missing newline at the end of /etc/default/grub
- Do not create the upgrade bootloader entry when the dnf dry-run actor stops the upgrade
- Enable in-place upgrade in case LUKS volumes are Ceph OSDs
- Fix SSSD service failing to start after upgrade
- Fix the false positive NFS storage detection on NFS servers and improve the report msg
- Fix the issues on systems with the LANGUAGE environment variable
- Fix the root directory scan to deal with non-utf8 filenames
- Fix various issues when upgrading the Satellite server
- Handle upgrades of SAP Apps systems using RHUI on Azure
- Handle upgrades on RHUI Google Cloud
- Inform about necessary migrations related to bacula-director when installed on the system
- Inhibit the upgrade when /var/lib/leapp being mounted in a non-persistent fashion to prevent failures
- Inhibit the upgrade when /var/lib/leapp mounted with the noexec option to prevent failures
- Make the application of custom selinux rules more reliable and do not override changes done by RPM scriptlets
- Mass refactoring to be compatible with leapp v0.15.0
- PESEventScanner actor has been fully refactored
- Skip comment lines when parsing the GRUB configuration file
- Resolves: rhbz#2090749, rhbz#1836179, rhbz#1885335, rhbz#1917314, rhbz#1937383, rhbz#2036069, rhbz#2071553, rhbz#2072550

* Wed Aug 17 2022 Petr Stodulka <pstodulk@redhat.com> - 0.16.0-8
- Fix migration of PostgreSQL data on satellite servers when data is on a separate
  partition
- Resolves: rhbz#2111835

* Fri Jul 15 2022 Michal Hecko <mhecko@redhat.com> - 0.16.0-7
- Fix upgrade failures due to ansible dependencies
- Fix upgrade when satellite-capsule is installed
- Fix PostgreSQL data ownership during the upgrade on satellite servers
- Resolves: rhbz#2087144, rhbz#2089887, rhbz#2104730

* Wed Apr 27 2022 Petr Stodulka <pstodulk@redhat.com> - 0.16.0-4
- Skip comments in /etc/default/grub during the parsing
- Resolves: rhbz#2065151

* Tue Apr 19 2022 Petr Stodulka <pstodulk@redhat.com> - 0.16.0-3
- Fix detection of devices and PCI drivers
- Use correct DNF repositories when upgrading Satellite server
- Resolves: rhbz#2065151

* Mon Apr 04 2022 Petr Stodulka <pstodulk@redhat.com> - 0.16.0-2
- Extend the check of deprecated or removed PCI drivers
- Resolves: rhbz#2065151

* Fri Mar 18 2022 Petr Stodulka <pstodulk@redhat.com> - 0.16.0-1
- Rebase to v0.16.0
- Improve the performance of the leapp execution for "pre first reboot" phases (rhbz#2013564)
- Changed upgrade paths:
  - RHEL 7.9 -> [8.4, 8.6]  (default: 8.6)
  - RHEL with SAP 7.9 -> [8.2, 8.6] (default: 8.2)
- Requires leapp-framework >= 2.2
- Bump leapp-framework-dependencies to 5
- Add detection of enabled YUM plugins (rhbz: #1913829)
- Bind the /run/lock dir into the container in the upgrade initramfs env
- Convert restrictions with IPv6 mask when migrating NTP
- Fix the execution order for the dnf dry run actor to ensure the check is valid
- Fix bug with existing symlinks when migrating YUM configuration files
- Fix generating the target initramfs when additional files and dracut modules are requested to be added
- Fix parsing of sysctl output during the scan of the system (rhbz: #2037843)
- Fix processing of PES data to produce correct instructions for DNF
- Fix scanning "/etc/default/grub" with empty lines
- Fix scanning information about mounted devices
- Handle correctl CUPS and Bind during the upgrade
- Handle upgrading Satellite instances
- Improve and generalize checking of device drivers
- Introduce DNFWorkarounds to register scripts to be executed before DNF run
- Introduce handling of DNF modularity during the upgrade
- Introduce the --report-schema option to control the version of the generated report format
- Introduce the --target option to specify the version of the target system (rhbz#1982127)
- Provide the LEAPP_IPU_IN_PROGRESS environment variable for actors during in-place upgrade
- Warn about docker deprecation when installed
- Zipl: Inhibit the upgrade if boot entries share the same kernel image
- Resolves: rhbz#2065151, rhbz#1913829, rhbz#2037843, rhbz#2013564, rhbz#1982127

* Wed Oct 27 2021 Petr Stodulka <pstodulk@redhat.com> - 0.15.0-6
- Fix the mapping of repositories on detached systems causing incorrect set
  of installed RHEL 8 packages during the upgrade
  Resolves: #2015578
- Fix the severity of new inhibitors
- Relates: #2015192

* Wed Oct 27 2021 Petr Stodulka <pstodulk@redhat.com> - 0.15.0-5
- Fix the regression introduced by the new --channel option
- Relates: #2015192

* Wed Oct 27 2021 Petr Stodulka <pstodulk@redhat.com> - 0.15.0-4
- Fix the creation of the answerfile
- Resolves: #2014015

* Wed Oct 20 2021 Petr Stodulka <pstodulk@redhat.com> - 0.15.0-3
- Correct the version-release to obsolete previous leapp-repository-deps rpm
- Resolves: #2015192

* Wed Oct 20 2021 Petr Stodulka <pstodulk@redhat.com> - 0.15.0-2
- Correct the version-release to obsolete previous leapp-repository rpm
- Resolves: #2015192

* Tue Oct 19 2021 Petr Stodulka <pstodulk@redhat.com> - 0.15.0-1
- Rebase to v0.15.0
- Changed supported upgrade path for: RHEL with SAP 7.9 -> 8.2
- Enable upgrades for SAP on AWS & Azure using RHUI
- The leapp-repository rpm has been renamed to leapp-upgrade-el7toel8
- Provides the leapp-upgrade capability, so all required packages can be installed
  by the `yum install leapp-upgrade` command
- Added a dependency on leapp as the new rpm provides leapp commands
- Bumped leapp-repository-dependencies to 6
- Do not exclude repoids enabled via the --enablerepo option (#623)
- Enforce the `en_US.utf-8` locale when running leapp to prevent various issues
  when a different locale is used on the system
- Enhance the check of required free space on disk for the upgrade
- Fix XFS ftype=0 workaround when "non-XFS" rootfs is present
- Fix detection of XFS partitions without ftype
- Fix handling of /etc/yum.repos.d directory for RHUI
- Fix incorrect mapping of RHEL repositories
- Fix the detection of NFS partitions in /etc/fstab (e.g. when nfs3 or nfs4 is specified)
- Fix the report message when multiple NICs with ethX names are present (#640)
- Fix handling of issues when fetching leapp data files
- Introduce the LEAPP_NO_NETWORK_RENAMING environment variable to leave management
  of NICs names on user when set to '1'; it's wanted e.g. in case a bonding
  is configured on the system
- Add actors to report about PostgresSQL changes
- Make generation of targetuserspace container, upgrade initramfs, and target initramfs more dynamic
- Require the /etc/dasd.conf file only when DASD is used on s390x
- Generate /etc/migration-results upon leapp preupgrade / upgrade execution to inform about status of the upgrade
- Improve the report message when BTRFS is detected
- Inhibit the upgrade if any CIFS entries found in /etc/fstab
- Inhibit the upgrade if any deprecated OpenSSH configuration options / directives are detected
- Inhibit the upgrade when multiple rescue boot entries exist on s390x
- Inhibit the upgrade when x32b and x64b versions of packages are installed
- Introduce hard preservation of leapp packages during the IPU to make the
  upgrade process more protected
- Introduce new system of automatic mapping of RHEL repositories for the in-place
  upgrade based on the repomap.json data file
- Introduce the --channel CLI option to specify the channel (e.g. eus) supposed
  to be used for the upgrade
- Report the problems with target repositories using inhibitors instead of error messages
- Update (or create) the /etc/{yum,dnf}/var/releasever file containing the target
  OS release if exists or RHUI is detected
- Introduced the upgrade/common leapp repository: contains fundamental parts
  generic for all in-place upgrades
- The upgrade/el7toel8 leapp repository contains only stuff related to in-place
  upgrade from RHEL 7 -> RHEL 8
- Resolves: #2015192

* Thu May 13 2021 Petr Stodulka <pstodulk@redhat.com> - 0.14.0-4
- Fix the check of removed non-pci drivers
  Relates: #1952886

* Tue May 04 2021 Petr Stodulka <pstodulk@redhat.com> - 0.14.0-3
- Fix handling of errors when fetching leapp data files from server
  Relates: #1952886

* Tue Apr 27 2021 Petr Stodulka <pstodulk@redhat.com> - 0.14.0-2
- Improve fetching of leapp data files from server (increase timeouts and
  retry multiple times in case of error)
- Relates: #1952886

* Fri Apr 23 2021 Petr Stodulka <pstodulk@redhat.com> - 0.14.0-1
- Rebase to v0.14.0
- Added dependency on python-requests on RHEL 7
- Changed supported upgrade paths:
    RHEL-ALT 7.6 -> 8.4
    RHEL 7.9 -> 8.4
    RHEL with SAP 7.7 -> 8.2 (unchanged)
- Download the leapp data from cloud.redhat.com automatically
  when no data are present locally (and system is registered)
- Fix migration of Quagga to FRR on RHEL 8.4
- Inhibit the upgrade if the system uses any drivers dropped
  from the RHEL 8 system
- Resolves: #1952886

* Thu Feb 04 2021 Dominik Rehak <drehak@redhat.com> - 0.13.0-2
- Rebuild
- Relates: #1915509

* Thu Feb 04 2021 Dominik Rehak <drehak@redhat.com> - 0.13.0-1
- Rebase to v0.13.0
- Add actors to migrate Quagga to FRR
- Add stable uniq Key id for every dialog
- Add upgrade support for SAP HANA
- Allow upgrade with SCA enabled manifest
- Fix comparison of the newest installed and booted kernel
- Fix crash due to missing network interfaces during upgrade phases
- Fix error with /boot/efi existing on non-EFI systems
- Fix false positive detection of issue in /etc/default/grub that led into GRUB
  prompt
- Fix remediation command for ipa-server removal
- Fix syntax error in upgrade script
- Inhibit upgrade if multiple kernel-debug pkgs are installed
- Inhibit upgrade on s390x machines with /boot on a separate partition
- Inhibit upgrade with mount options in fstab that break mounting on RHEL 8
- Remove the *leapp-resume* service after the *FirstBoot* phase to prevent kill
  of the leapp process on `systemctl daemon-reload`
- Remove the initial-setup package to avoid it asking for EULA acceptance during
  upgrade
- Require the leapp-framework capability 1.4
- Respect the *kernel-rt* package
- Resolves: #1915509 #1872356 #1873312 #1899455 #1901002 #1905247 #1870813
- Relates: #1901440

* Sun Oct 25 2020 Petr Stodulka <pstodulk@redhat.com> - 0.12.0-2
- Add actors to migrate Quagga to FRR
- Fixes issues with interrupted leapp during the FirstBoot phase when reload
  of daemons is required
  Resolves: #1883218
- Relates: #1887912

* Wed Oct 21 2020 Dominik Rehak <drehak@redhat.com> - 0.12.0-1
- Rebase to v0.12.0
- Enable upgrades on AWS and Azure
- Check usage of removed/deprecated leapp env vars
- Do not inhibit if winbind or wins is used in nsswitch.conf
  (as the issue is fixed in RHEL 8.2)
- Do not remove java from the upgrade transaction
- Fix handling of events with same initial releases and input packages
- Fix mkhomedir issues after authselect conversion
- Fix python macro error in spec file
- Fix storing of logs from initramfs
- Handle migration of authselect and PAM
- Improve remediation instructions for HA clusters
- Make sure "default.target.wants" dir exists
- Resolves: #1887912

* Tue Sep 15 2020 Dominik Rehak <drehak@redhat.com> - 0.11.0-4
- Remove java from the upgrade transaction
  Relates: #1860375

* Tue Sep 08 2020 Petr Stodulka <pstodulk@redhat.com> - 0.11.0-3
- Set authselect and PAM actors experimental again
  Relates: #1860375

* Wed Sep 02 2020 Petr Stodulka <pstodulk@redhat.com> - 0.11.0-2
- Make possible upgrade with the java-11-openjdk-headless package
- Fix check of local repositories when metalink or mirrorlist is specified
- Relates: #1860375

* Tue Aug 18 2020 Michal Bocek <mbocek@redhat.com> - 0.11.0-1
- Rebase to v0.11.0
- Do not crash when the /root/temp_leapp_py3 directory exists (when upgrade is executed multiple times)
  Relates: #1858479
- Do not detect grub device on the s390x architecture (ZIPL is used there)
- Consider the katello rpm being signed by Red Hat
- Omit printing grub binary data on terminal which could break terminal output
- Provide just a single remedition command in the pre-upgrade report to be compatible with Satellite and Cockpit
- Search repository files only in directories used by DNF
- Change supported upgrade paths: RHEL-ALT 7.6 -> 8.2; RHEL 7.9 -> 8.2
- Check whether PAM modules, that are not present on RHEL 8, are used
- Inhibit upgrade when local repositories (referred by file://) are detected
- Introduce actors for migration of Authconfig to Authselect
- Support for an in-place upgrade for z15 machines - s390x architecture
- Update list of removed drivers on RHEL 8
- Resolves: #1860375

* Mon Apr 20 2020 Michal Bocek <mbocek@redhat.com> - 0.10.0-2
- Fixed broken cli output due to printing binary data
- Relates: #1821710

* Thu Apr 16 2020 Petr Stodulka <pstodulk@redhat.com> - 0.10.0-1
- Rebase to v0.10.0
- Changed upgrade paths: RHEL-ALT 7.6 -> 8.2; RHEL 7.8 -> 8.2
- Add initial multipath support (it doesn't handle all cases yet)
- Use the new framework mechanism to inhibit the upgrade without reporting errors
- Support the upgrade without the use of subscription-manager
- Add dependency on leapp-framework
- Check if the latest installed kernel is booted before the upgrade
- Check that the system satisfies minimum memory requirements
  for the upgrade (#413)
- Do not mount pseudo and unsupposrted FS to overlayfs (e.g. proc)
- Drop leapp sos plugin (it's part of the sos rpm in RHEL 7.7+)
- Evaluate PES events transitively to create correct data for the upgrade
  transaction
- Fix checking of kernel drivers (#400)
- Fix failures caused by local rpms added into the upgrade transaction
- Fix getting mount information with mountpoints with spaces in the path
- Fix handling of XFS without ftype for every such mounted FS
- Fix issue with random booting into old RHEL 7 kernel after the upgrade
- Fix issues on systems with statically mapped IPs in /etc/hosts
- Fix issues with device mapper and udev in a container
- Fix issues with failing rpm transaction calculation because of duplicate
  instructions for dnf
- Fix various issues related to RHSM (including rhbz rhbz#1702691)
- Fix yum repository scan in case of repositories with invalid URL
- Improved report related to KDE/GNOME
- Inhibit the upgrade for ipa-server (#481)
- Inhibit the upgrade if multiple kernel-devel rpms are installed
- Inhibit the upgrade on FIPS systems
- Inhibit the upgrade when links on root dir '/' are not absolute to save the world
- Inhibit the upgrade when the raised dialogs are missing answers (#589)
- Introduce new ways of using custom repositories during the transaction
- Make report messages more explicit about Dialogs (#600)
- Migrate SpamAssassin
- Migrate cups-filters
- Migrate sane-backend
- Modify vim configuration to keep the original behaviour
- Parse correctly kernel cmdline inside the initrd (#383) (fixes various issues on s390x)
- Print warnings instead of a hard failure when expected rpms cannot be found
  (e.g. python3-nss inside an rpm module) (#405)
- Remove java11-openjdk-headless during the upgrade (rhbz#1820172)
- Report changes in wireshark
- The name and baseurl field in the CustomTargetRepository message are optional now
- Throw a nice error when invalid locale is set (#430)
- Various texts are improved based on the feedback
- Resolves: #1821710

* Tue Nov 5 2019 Petr Stodulka <pstodulk@redhat.com> - 0.9.0-5
- Do not use efibootmgr on non-efi systems
  Resolves: #1768904

* Mon Nov 4 2019 Petr Stodulka <pstodulk@redhat.com> - 0.9.0-4
- Inhibit upgrade on EFI systems when efibootmgr is not installed
  Relates: #1753580

* Fri Nov 1 2019 Petr Stodulka <pstodulk@redhat.com> - 0.9.0-3
- Inhibit upgrade on s390x machines with rd.znet in kernel cmdline to prevent
  troubles with networking (temporary)
- Fix issues with failing rpm transaction calculation because of duplicates
- Fix boot order on EFI systems
  Relates: #1753580

* Wed Oct 30 2019 Michal Bocek <mbocek@redhat.com> - 0.9.0-2
- Fixed some remediation instructions
- Not trying to make an overlay over /boot/efi
  Relates: #1753580

* Thu Oct 24 2019 Petr Stodulka <pstodulk@redhat.com> - 0.9.0-1
- Rebase to v0.9.0
- Added dependency on policycoreutils-python
- Change upgrade path from RHEL(-ALT) 7.6 (EUS) to RHEL 8.1
- Changed the title of the upgrade boot entry to be valid for ZIPL
- Check NSS configuration for use of wins or winbind
- Check SSSD configuration
- Check use of removed PAM modules
- Check whether CPU on s390x is supported on RHEL 8
- Do not remove packages which shall be installed/kept on target system
- Do not waste time by downloading of RPMs if upgrade has been inhibited already
- Enable and make possible upgrades on all architectures
- Enable repositories used for upgrade on the upgraded system
- Fix adding of local rpms into the upgrade transaction
- Fix check of active kernel modules
- Fix handling of XFS filesystems with ftype=0 (rhbz#1746956)
- Fix ntp migration: extract configs into the right directories
- Fix traceback when RHSM is skipped
- Handle possible error when setting release on upgraded system
- Handle systems with EFI boot
- Handle upgrade on systems with multiple partitions
- Improve message on failed subscription-manager and dnf
- Improved the reporting capability
- Migrate SELinux customizations
- No size limit on leapp.db in sosreport
- Process new PES data format + process PES events in order of releases
- Require the biosdevname dracut module on the intel architecture only
- Retry some actions of subscription-manager on failure to reduce number of issues
- Update the list of packages supposed to be removed during the upgrade
- Upgrade only packages signed by Red Hat
  Resolves: #1753580

* Thu Jul 25 2019 Petr Stodulka <pstodulk@redhat.com> - 0.8.1-2
- attempt to (un)set rhsm release several times to omit possible problems with
  server
  Relates: #1723115

* Wed Jul 24 2019 Petr Stodulka <pstodulk@redhat.com> - 0.8.1-1
- Rebase to v0.8.1
  Relates: #1723115
- enable installation of RPMs that were previously blacklisted due to problems
  with rich dependencies

* Mon Jul 15 2019 Petr Stodulka <pstodulk@redhat.com> - 0.8.0-1
- Rebase to v0.8.0
  Relates: #1723115
- improve handling of RPM transaction to be able to process RPMs with
  rich dependencies
- add missing dependency on python-udev & python3-udev
- fix processing of last phase during the first boot of the upgraded system
- set RHSM target release after the upgrade to expected version of the system
- enable the CRB repository when the Optional repository is enabled
- check tcp wrappers
- check OpenSSH configuration
- check and handle vftpd configuration
- check kernel drivers
- improve checks related to subscriptions
- improve parsing of /etc/fstab
- ensure the new target kernel is default boot entry
- handle better cases when no target repositories has been found
- migrate NTP to chronyd
- migrate brltty configuration
- migrate sendmail
- avoid removal of /etc/localtime and /etc/resolv.conf during the upgrade
- add informational actors for: acpid, chrony, dosfstools, grep, irssi,
  postfix, powertop

* Sun Jun 23 2019 Vojtech Sokol <vsokol@redhat.com> - 0.7.0-6
- Rebuild
  Resolves: #1723115

* Fri Apr 26 2019 Petr Stodulka <pstodulk@redhat.com> - 0.7.0-5
- build rhel8 initrd on the fly during the upgrade process
- do not bundle initrd and vmlinuz file in the rpm
  Relates: #1636481

* Fri Apr 26 2019 Petr Stodulka <pstodulk@redhat.com> - 0.7.0-4
- add python2-docs and python3-docs to the list of rpms for removal as
  currently it causes troubles with RPM transaction
  Relates: #1636481

* Fri Apr 26 2019 Petr Stodulka <pstodulk@redhat.com> - 0.7.0-3
- set selinux into the permissive mode on RHEL 8 when enforcing was set
  originally
- add python-docs and squid rpms to the list of rpms for removal
  Relates: #1636481

* Wed Apr 17 2019 Petr Stodulka <pstodulk@redhat.com> - 0.7.0-2
- fix inhibition when ethX network interface exists and more additional NIC
  exist as well
  Relates: #1636481

* Wed Apr 17 2019 Petr Stodulka <pstodulk@redhat.com> - 0.7.0-1
- Rebase to v0.7.0
  Relates: #1636481
- new dependencies: python3, python*-pyudev
- upgrade process is interrupted after RPMUpgradePhase and resumed with Python3
- upgrade of NetworkManager is fixed
- upgrade of firewalld is handled
- name changes of network interfaces are handled
- HTB repositories used for upgrades are replaced with the ones used for GA
- tpm2-abrmd and all packages that depend on redhat-rpm-config are removed
  during upgrade
- handling of the upgrade RPM transaction is improved
- sync command is used in initrd to avoid issues related to cache
- networking naming changes are handled
- disable udev's persistent network interface naming scheme when the only NIC
  is eth0
- inhibit upgrade when ethX is detected and more NICs exist
- check whether all target upgrade repositories are available
- output of dnf tool is always showed during the upgrade
- all logs and reports are stored in /var/log/leapp/ directory


* Tue Apr 09 2019 Vojtech Sokol <vsokol@redhat.com> - 0.6.0-4
- Remove wrong license for sos subpackage
  Relates: #1636481

* Mon Apr 08 2019 Vojtech Sokol <vsokol@redhat.com> - 0.6.0-3
- Fix patch
  Relates: #1636481

* Mon Apr 08 2019 Vojtech Sokol <vsokol@redhat.com> - 0.6.0-2
- Fix specfile
  Relates: #1636481

* Mon Apr 08 2019 Vojtech Sokol <vsokol@redhat.com> - 0.6.0-1
- Rebase to v0.6.0
  Relates: #1636481
- Change license to Apache 2.0
- leapp-repository-data subpackage is removed (it included data files)
  - data files are required to be delivered by user manually now
- udev database is accessible during the upgrade
- downtime of some machines is significantly reduced
- sos plugin is introduced for collecting data needed for debugging
- redhat-rpm-config package is removed during upgrade
- system is checked for NFS filesystems usage and upgrade is inhibited when
  detected
- /boot is checked for sufficient free space
- upgrade is not inhibited any more when Logic SCSI Controllers are present
- repositories used to upgrade the system are based on provided data files
- specific syntax errors in grub configuration are handled when detected
- SCTP is handled during the upgrade
- migration of yum is handled (yum is available after the upgrade)
- upgrade of NetworkManager is handled
- upgrades with XFS filesystems without ftype is handled better
- new reporting functionality is introduced and used
- new dependencies: python2-jinja2, pciutils, sos
- new directory /etc/leapp/files for data files is introduced
- python files are precompiled to avoid left over pyc files

* Thu Jan 24 2019 Petr Stodulka <pstodulk@redhat.com> - 0.5.0-1
- Rebase to v0.5.0
  Relates: #1636481
- Require DNF v4+ and Leapp framework v0.5.0
- Improved handling of RPM transaction using own DNF plugin and PES
  data
- Models have been refactored to use new format supported by framework
- Handle transaction preparation when release is set through RHSM
- Fix failing overlayfs unmounting
- Reduce the IPUWorkflo workflow
- Include all required directories inside RPMs
- Handle repositories using metalink and mirrorlist
- Handle better installation of local RPMs
- Move system dependencies into the RPM metapackage
- Satisfy leapp and leapp-repository RPM dependencies during the
  upgrade

* Thu Jan 03 2019 Petr Stodulka <pstodulk@redhat.com> - 0.4.0-4
- Activate LVM LVs during upgrade
- Resolve file conflict of python-inotify during the RPM transaction
  Relates: #1636481

* Thu Nov 29 2018 Petr Stodulka <pstodulk@redhat.com> - 0.4.0-3
- Add empty empty events for leapp-repository-data.
- Requiring now DNF 2.7.5-19 or higher
  Relates: #1636481

* Wed Nov 21 2018 Petr Stodulka <pstodulk@redhat.com> - 0.4.0-2
- update leapp-repository-data source
  Relates: #1636481

* Wed Nov 21 2018 Petr Stodulka <pstodulk@redhat.com> - 0.4.0-1
- Rebase to 0.4.0
- change hierarchy of repositories
- scan RHEL system for custom and 3rd-party packages
- improve error messages
  Relates: #1636481

* Fri Nov 09 2018 Petr Stodulka <pstodulk@redhat.com> - 0.3.1-1
- Rebase to 0.3.1
- move data to separate subpackage
  Relates: #1636481

* Wed Nov 07 2018 Petr Stodulka <pstodulk@redhat.com> - 0.3-1
- Initial RPM
  Resolves: #1636481

